/************************************************************

Created: Friday, October 20, 1989 at 6:23 AM
	Memory.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	1985-1990
	All rights reserved

************************************************************/


#ifndef __MEMORY__
#define __MEMORY__

#ifndef __TYPES__
#include <Types.h>
#endif

enum {maxSize = 0x800000};  /*Max data block size is 8 megabytes*/

typedef long Size;
typedef pascal long (*GrowZoneProcPtr)(Size cbNeeded);

struct Zone {
	Ptr bkLim;
	Ptr purgePtr;
	Ptr hFstFree;
	long zcbFree;
	GrowZoneProcPtr gzProc;
	short moreMast;
	short flags;
	short cntRel;
	short maxRel;
	short cntNRel;
	short maxNRel;
	short cntEmpty;
	short cntHandles;
	long minCBFree;
	ProcPtr purgeProc;
	Ptr sparePtr;
	Ptr allocPtr;
	short heapData;
};

typedef struct Zone Zone;
typedef Zone *THz;

#ifdef __cplusplus
extern "C" {
#endif
#pragma parameter __A0 GetApplLimit
pascal Ptr GetApplLimit(void)
	= {0x2078,0x0130};
#pragma parameter __A0 GetZone
pascal THz GetZone(void)
	= 0xA11A;
#pragma parameter __A0 SystemZone
pascal THz SystemZone(void)
	= {0x2078,0x02A6};
#pragma parameter __A0 ApplicZone
pascal THz ApplicZone(void)
	= {0x2078,0x02AA};
#pragma parameter __A0 NewHandle(__D0)
pascal Handle NewHandle(Size byteCount)
	= 0xA122;
#pragma parameter __A0 NewHandleSys(__D0)
pascal Handle NewHandleSys(Size byteCount)
	= 0xA522; 
#pragma parameter __A0 NewHandleClear(__D0)
pascal Handle NewHandleClear(Size byteCount)
	= 0xA322;
#pragma parameter __A0 NewHandleSysClear(__D0)
pascal Handle NewHandleSysClear(Size byteCount)
	= 0xA722;
#pragma parameter __A0 HandleZone(__A0)
pascal THz HandleZone(Handle h)
	= 0xA126;
#pragma parameter __A0 RecoverHandle(__A0)
pascal Handle RecoverHandle(Ptr p)
	= 0xA128; 
#pragma parameter __A0 RecoverHandleSys(__A0)
pascal Handle RecoverHandleSys(Ptr p)
	= 0xA528; 
#pragma parameter __A0 NewPtr(__D0)
pascal Ptr NewPtr(Size byteCount)
	= 0xA11E;
#pragma parameter __A0 NewPtrSys(__D0)
pascal Ptr NewPtrSys(Size byteCount)
	= 0xA51E;
#pragma parameter __A0 NewPtrClear(__D0)
pascal Ptr NewPtrClear(Size byteCount)
	= 0xA31E; 
#pragma parameter __A0 NewPtrSysClear(__D0)
pascal Ptr NewPtrSysClear(Size byteCount)
	= 0xA71E;
#pragma parameter __A0 PtrZone(__A0)
pascal THz PtrZone(Ptr p)
	= 0xA148;
#pragma parameter __A0 GZSaveHnd
pascal Handle GZSaveHnd(void)
	= {0x2078,0x0328};
#pragma parameter __A0 TopMem
pascal Ptr TopMem(void)
	= {0x2078,0x0108};
#pragma parameter __D0 MaxBlock
pascal long MaxBlock(void)
	= 0xA061; 
#pragma parameter __D0 MaxBlockSys
pascal long MaxBlockSys(void)
	= 0xA461; 
#pragma parameter __D0 StackSpace
pascal long StackSpace(void)
	= 0xA065;
#pragma parameter __A0 NewEmptyHandle
pascal Handle NewEmptyHandle(void)
	= 0xA166; 
#pragma parameter __A0 NewEmptyHandleSys
pascal Handle NewEmptyHandleSys(void)
	= 0xA566; 
#pragma parameter HLock(__A0)
pascal void HLock(Handle h)
	= 0xA029;
#pragma parameter HUnlock(__A0)
pascal void HUnlock(Handle h)
	= 0xA02A;
#pragma parameter HPurge(__A0)
pascal void HPurge(Handle h)
	= 0xA049;
#pragma parameter HNoPurge(__A0)
pascal void HNoPurge(Handle h)
	= 0xA04A; 
#if (SystemSixOrBetter)
#pragma parameter __D0 StripAddress(__D0)
pascal Ptr StripAddress(Ptr theAddress)
	= 0xA055;
#else
pascal Ptr StripAddress(Ptr theAddress);
#endif
pascal Size MFMaxMem(Size *grow)
	= {0x3F3C,0x0015,0xA88F};
pascal long MFFreeMem(void)
	= {0x3F3C,0x0018,0xA88F};
pascal Handle MFTempNewHandle(Size logicalSize,OSErr *resultCode)
	= {0x3F3C,0x001D,0xA88F};
pascal void MFTempHLock(Handle h,OSErr *resultCode)
	= {0x3F3C,0x001E,0xA88F};
pascal void MFTempHUnlock(Handle h,OSErr *resultCode)
	= {0x3F3C,0x001F,0xA88F};
pascal void MFTempDisposHandle(Handle h,OSErr *resultCode)
	= {0x3F3C,0x0020,0xA88F};
pascal Ptr MFTopMem(void)
	= {0x3F3C,0x0016,0xA88F};
pascal void InitApplZone(void)
	= 0xA02C; 
pascal void InitZone(GrowZoneProcPtr pgrowZone,short cmoreMasters,Ptr limitPtr,
	Ptr startPtr);
#pragma parameter SetZone(__A0)
pascal void SetZone(THz hz)
	= 0xA01B;
#pragma parameter __D0 CompactMem(__D0)
pascal Size CompactMem(Size cbNeeded)
	= 0xA04C;
#pragma parameter __D0 CompactMemSys(__D0)
pascal Size CompactMemSys(Size cbNeeded)
	= 0xA44C;
#pragma parameter PurgeMem(__D0)
pascal void PurgeMem(Size cbNeeded)
	= 0xA04D;
#pragma parameter PurgeMemSys(__D0)
pascal void PurgeMemSys(Size cbNeeded)
	= 0xA44D;
#pragma parameter __D0 FreeMem
pascal long FreeMem(void)
	= 0xA01C;
#pragma parameter __D0 FreeMemSys
pascal long FreeMemSys(void)
	= 0xA41C;
#pragma parameter ResrvMem(__D0)
pascal void ResrvMem(Size cbNeeded)
	= 0xA040;
#pragma parameter ReserveMem(__D0)
pascal void ReserveMem(Size cbNeeded)
	= 0xA040;
#pragma parameter ReserveMemSys(__D0)
pascal void ReserveMemSys(Size cbNeeded)
	= 0xA440;
#pragma parameter __D0 MaxMem(__A1)
pascal Size MaxMem(Size *grow)
	= {0xA11D,0x2288}; 
#pragma parameter __D0 MaxMemSys(__A1)
pascal Size MaxMemSys(Size *grow)
	= {0xA51D,0x2288}; 
#pragma parameter SetGrowZone(__A0)
pascal void SetGrowZone(GrowZoneProcPtr growZone)
	= 0xA04B;
#pragma parameter SetApplLimit(__A0)
pascal void SetApplLimit(Ptr zoneLimit)
	= 0xA02D;
#pragma parameter MoveHHi(__A0)
pascal void MoveHHi(Handle h)
	= 0xA064;
#pragma parameter DisposPtr(__A0)
pascal void DisposPtr(Ptr p)
	= 0xA01F;
#pragma parameter DisposePtr(__A0)
pascal void DisposePtr(Ptr p)
	= 0xA01F;
pascal Size GetPtrSize(Ptr p);
#pragma parameter SetPtrSize(__A0,__D0)
pascal void SetPtrSize(Ptr p,Size newSize)
	= 0xA020; 
#pragma parameter DisposHandle(__A0)
pascal void DisposHandle(Handle h)
	= 0xA023; 
#pragma parameter DisposeHandle(__A0)
pascal void DisposeHandle(Handle h)
	= 0xA023; 
pascal Size GetHandleSize(Handle h);
#pragma parameter SetHandleSize(__A0,__D0)
pascal void SetHandleSize(Handle h,Size newSize)
	= 0xA024;
#pragma parameter EmptyHandle(__A0)
pascal void EmptyHandle(Handle h)
	= 0xA02B;
#pragma parameter ReallocHandle(__A0,__D0)
pascal void ReallocHandle(Handle h,Size byteCount)
	= 0xA027; 
#pragma parameter HSetRBit(__A0)
pascal void HSetRBit(Handle h)
	= 0xA067; 
#pragma parameter HClrRBit(__A0)
pascal void HClrRBit(Handle h)
	= 0xA068; 
pascal void MoreMasters(void)
	= 0xA036;
#pragma parameter BlockMove(__A0,__A1,__D0)
pascal void BlockMove(Ptr srcPtr,Ptr destPtr,Size byteCount)
	= 0xA02E;
pascal OSErr MemError(void)
	= {0x3EB8,0x0220};
pascal void PurgeSpace(long *total,long *contig);
#pragma parameter __D0 HGetState(__A0)
pascal char HGetState(Handle h)
	= 0xA069;
#pragma parameter HSetState(__A0,__D0)
pascal void HSetState(Handle h,char flags)
	= 0xA06A;
#pragma parameter SetApplBase(__A0)
pascal void SetApplBase(Ptr startPtr)
	= 0xA057;
pascal void MaxApplZone(void)
	= 0xA063;
#ifdef __cplusplus
}
#endif

#endif
