/************************************************************

Created: Thursday, January 25, 1990 at 1:37 PM
	OSUtils.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	1985-1990
	All rights reserved
	
	Dont use:
	-SetUpA5
	-RestoreA5
	Instead:
	SetUpA5 --> myA5 = SetCurrentA5();
	RestoreA5 --> oldA5 = SetA5(myA5);
	
************************************************************/


#ifndef __OSUTILS__
#define __OSUTILS__

#ifndef __TYPES__
#include <Types.h>
#endif

enum {useFree = 0};
enum {useATalk = 1};
enum {useAsync = 2};
enum {useExtClk = 3};       /*Externally clocked*/
enum {useMIDI = 4};

/* *** Environs Equates *** */

enum {curSysEnvVers = 2};   /*Updated to equal latest SysEnvirons version*/

/*  Machine Types  */

enum {envMac = -1};
enum {envXL = -2};
enum {envMachUnknown = 0};
enum {env512KE = 1};
enum {envMacPlus = 2};
enum {envSE = 3};
enum {envMacII = 4};
enum {envMacIIx = 5};
enum {envMacIIcx = 6};
enum {envSE30 = 7};
enum {envPortable = 8};
enum {envMacIIci = 9};
enum {envMacIIfx = 11};

/* CPU types */

enum {envCPUUnknown = 0};
enum {env68000 = 1};
enum {env68010 = 2};
enum {env68020 = 3};
enum {env68030 = 4};
enum {env68040 = 5};

/* Keyboard types */

enum {envUnknownKbd = 0};
enum {envMacKbd = 1};
enum {envMacAndPad = 2};
enum {envMacPlusKbd = 3};
enum {envAExtendKbd = 4};
enum {envStandADBKbd = 5};
enum {envPrtblADBKbd = 6};
enum {envPrtblISOKbd = 7};
enum {envStdISOADBKbd = 8};
enum {envExtISOADBKbd = 9};
enum {false32b = 0};        /*24 bit addressing error*/
enum {true32b = 1};         /*32 bit addressing error*/

/* result types for RelString Call */

enum {sortsBefore = -1};    /*first string < second string*/
enum {sortsEqual = 0};      /*first string = second string*/
enum {sortsAfter = 1};      /*first string > second string*/

enum {dummyType,vType,ioQType,drvQType,evType,fsQType,sIQType,dtQType};
typedef unsigned short QTypes;

enum {OSTrap,ToolTrap};
typedef unsigned char TrapType;

struct SysParmType {
	char valid;
	char aTalkA;
	char aTalkB;
	char config;
	short portA;
	short portB;
	long alarm;
	short font;
	short kbdPrint;
	short volClik;
	short misc;
};

typedef struct SysParmType SysParmType;
typedef SysParmType *SysPPtr;

struct QElem {
	struct QElem *qLink;
	short qType;
	short qData[1];
};

typedef struct QElem QElem;
typedef QElem *QElemPtr;

struct QHdr {
	short qFlags;
	QElemPtr qHead;
	QElemPtr qTail;
};

typedef struct QHdr QHdr;
typedef QHdr *QHdrPtr;

struct DateTimeRec {
	short year;
	short month;
	short day;
	short hour;
	short minute;
	short second;
	short dayOfWeek;
};

typedef struct DateTimeRec DateTimeRec;
struct SysEnvRec {
	short environsVersion;
	short machineType;
	short systemVersion;
	short processor;
	Boolean hasFPU;
	Boolean hasColorQD;
	short keyBoardType;
	short atDrvrVersNum;
	short sysVRefNum;
};

typedef struct SysEnvRec SysEnvRec;

#ifdef __cplusplus
extern "C" {
#endif
#define GetSysPPtr() ((SysPPtr) 0x01F8)
pascal void SysBeep(short duration)
	= 0xA9C8;
pascal long KeyTrans(Ptr transData,short keycode,long *state)
	= 0xA9C3;
#pragma parameter __D0 DTInstall(__A0)
pascal OSErr DTInstall(QElemPtr dtTaskPtr)
	= 0xA082; 
#pragma parameter __D0 GetMMUMode
pascal char GetMMUMode(void)
	= {0x1038,0x0CB2};
#pragma parameter SwapMMUMode(__A0)
pascal void SwapMMUMode(char *mode)
	= {0x1010,0xA05D,0x1080};
#if SystemSixOrBetter
#pragma parameter __D0 SysEnvirons(__D0,__A0)
pascal OSErr SysEnvirons(short versionRequested,SysEnvRec *theWorld)
	= 0xA090;
#else
pascal OSErr SysEnvirons(short versionRequested,SysEnvRec *theWorld);
#endif
#pragma parameter __D0 ReadDateTime(__A0)
pascal OSErr ReadDateTime(unsigned long *time)
	= 0xA039;
#pragma parameter GetDateTime(__A0)
pascal void GetDateTime(unsigned long *secs)
	= {0x20B8,0x020C};
#pragma parameter __D0 SetDateTime(__D0)
pascal OSErr SetDateTime(unsigned long time)
	= 0xA03A;
#pragma parameter SetTime(__A0)
pascal void SetTime(const DateTimeRec *d)
	= {0xA9C7,0xA03A};
#pragma parameter GetTime(__A0)
pascal void GetTime(DateTimeRec *d)
	= {0x2038,0x020C,0xA9C6};
pascal void Date2Secs(const DateTimeRec *d,unsigned long *s);
#pragma parameter Secs2Date(__D0,__A0)
pascal void Secs2Date(unsigned long s,DateTimeRec *d)
	= 0xA9C6;
#pragma parameter Delay(__A0,__A1)
pascal void Delay(long numTicks,long *finalTicks)
	= {0xA03B,0x2280};
#pragma parameter __A0 GetTrapAddress(__D0)
pascal long GetTrapAddress(short trapNum)
	= 0xA146;
#pragma parameter SetTrapAddress(__A0,__D0)
pascal void SetTrapAddress(long trapAddr,short trapNum)
	= 0xA047;
pascal long NGetTrapAddress(short trapNum,TrapType tTyp);
pascal void NSetTrapAddress(long trapAddr,short trapNum,TrapType tTyp);
#pragma parameter __A0 GetOSTrapAddress(__D0)
pascal long GetOSTrapAddress(short trapNum)
	= 0xA346;
#pragma parameter SetOSTrapAddress(__A0,__D0)
pascal void SetOSTrapAddress(long trapAddr,short trapNum)
	= 0xA247;
#pragma parameter __A0 GetToolTrapAddress(__D0)
pascal long GetToolTrapAddress(short trapNum)
	= 0xA746;
#pragma parameter SetToolTrapAddress(__A0,__D0)
pascal void SetToolTrapAddress(long trapAddr,short trapNum)
	= 0xA647;
pascal OSErr WriteParam(void);
pascal Boolean EqualString(const Str255 str1,const Str255 str2,Boolean caseSens,
	Boolean diacSens);
Boolean equalstring(char *str1,char *str2,Boolean caseSens,Boolean diacSens);
pascal void UprString(Str255 theString,Boolean diacSens);
void uprstring(char *theString,Boolean diacSens);
#pragma parameter Enqueue(__A0,__A1)
pascal void Enqueue(QElemPtr qElement,QHdrPtr qHeader)
	= 0xA96F; 
#pragma parameter __D0 Dequeue(__A0,__A1)
pascal OSErr Dequeue(QElemPtr qElement,QHdrPtr qHeader)
	= 0xA96E;
long SetCurrentA5(void)
	= {0x200D,0x2A78,0x0904};
#pragma parameter __D0 SetA5(__D0)
long SetA5(long newA5)
	= 0xC18D;
pascal void Environs(short *rom,short *machine);
pascal short RelString(const Str255 str1,const Str255 str2,Boolean caseSens,
	Boolean diacSens);
short relstring(char *str1,char *str2,Boolean caseSens,Boolean diacSens);
pascal OSErr HandToHand(Handle *theHndl);
#pragma parameter __D0 PtrToXHand(__A0,__A1,__D0)
pascal OSErr PtrToXHand(Ptr srcPtr,Handle dstHndl,long size)
	= 0xA9E2;
pascal OSErr PtrToHand(Ptr srcPtr,Handle *dstHndl,long size);
#pragma parameter __D0 HandAndHand(__A0,__A1)
pascal OSErr HandAndHand(Handle hand1,Handle hand2)
	= 0xA9E4;
#pragma parameter __D0 PtrAndHand(__A0,__A1,__D0)
pascal OSErr PtrAndHand(Ptr ptr1,Handle hand2,long size)
	= 0xA9EF;
#pragma parameter __D0 InitUtil
pascal OSErr InitUtil(void)
	= 0xA03F;
pascal Boolean SwapInstructionCache(Boolean cacheEnable);
pascal void FlushInstructionCache(void);
pascal Boolean SwapDataCache(Boolean cacheEnable);
pascal void FlushDataCache(void);
#ifdef __cplusplus
	}
#endif

#endif
