{
	Created: Wednesday, November 1, 1989
	PPCToolBox.p
	Pascal Interface to the Macintosh Libraries

	Copyright Apple Computer, Inc.	1989-1990
	All rights reserved
}

{$IFC UNDEFINED UsingIncludes}
	{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT PPCToolBox;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingPPCToolBox}
{$SETC UsingPPCToolBox := 1}

{$I+}
{$SETC PPCToolBoxIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingMemory}
{$I $$Shell(PInterfaces)Memory.p}
{$ENDC}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$IFC UNDEFINED UsingAppleTalk}
{$I $$Shell(PInterfaces)AppleTalk.p}
{$ENDC}
{$SETC UsingIncludes := PPCToolBoxIncludes}

CONST

{ -900 to -950 are reserved for PPC    }		{### some capitalization changed }
	notInitErr		  = -900;
	tooManyPortsErr   = -901;
	nameTypeErr 	  = -902;
	noPortErr		  = -903;
	noGlobalsErr	  = -904;
	localOnlyErr	  = -905;
	destPortErr 	  = -906;
	sessTableErr	  = -907;
	noSessionErr	  = -908;
	badReqErr		  = -909;
	portNameExistsErr = -910;
	noPortTableErr	  = -911;
	userRejectErr	  = -912;
	noMachineNameErr  = -913;
	noToolboxNameErr  = -914;
	noResponseErr	  = -915;
	portClosedErr	  = -916;
	sessClosedErr	  = -917;
	atalkPhaseErr	  = -918; { apple talk is not phase 2 }
	badPortNameErr	  = -919;
	loginCancelErr	  = -920;
	unknownUserErr	  = -921;
	noDefaultUserErr  = -922;
	notLoggedInErr	  = -923;
	noUserRefErr	  = -924;
	networkErr		  = -925;
	noInformErr 	  = -926;
	authFailErr 	  = -927;
	noUserRecErr	  = -928;
	notSupportedErr   = -929;
	badServiceMethodErr =  -930;
	badLocNameErr	  = -931;
	guestNotAllowedErr = -932;

	ppcServiceRealTime	=	1;

	ppcNoLocation		=	0;	{ There is no PPCLocName }
	ppcNBPLocation		=	1;	{ Use AppleTalk NBP }
	ppcNBPTypeLocation	=	2;	{ Use just the NBP type, fill in rest with default }

	ppcByCreatorAndType	=	1;	{ Port type is specified as colloquial Mac creator and type }
	ppcByString 		=	2;	{ Port type is in pascal string format }

	ppcLocalOrigin		=	1;	{ session originated from this machine }
	ppcRemoteOrigin		=	2;	{ session originated from remote machine }


TYPE
	PPCServiceType 		= 	SignedByte;
	PPCLocationKind		=	Integer;
	PPCPortKinds		=	Integer;
	PPCSessionOrigin	=	SignedByte;	{ requestType returned in PPCInform }
	PPCPortRefNum 		= 	Integer;
	PPCSessRefNum 		= 	LongInt;
	{ Procedures you will need to write }
	PPCFilterProcPtr = ProcPtr; { FUNCTION MyPortFilter(locationName: LocationNameRec; thePortInfo: PortInfoRec): Boolean; }
	PPCCompProcPtr	 = ProcPtr; { PROCEDURE MyCompletionRoutine(pb: PPCParamBlockPtr); }

	PPCPortPtr 		=	^PPCPortRec;	
	PPCPortRec		=	RECORD
							nameScript:			ScriptCode;			{ script of name }
							name:				Str32;				{ name of port as seen in browser }
							portKindSelector:	PPCPortKinds;		{ which variant }
							CASE PPCPortKinds OF
								ppcByString:
									(portTypeStr:	Str32);
								ppcByCreatorAndType:
									(portCreator:	OSType;
									 portType:		OSType)
						END;

	LocationNamePtr =	^LocationNameRec;
	LocationNameRec	=	RECORD
							locationKindSelector : PPCLocationKind;	{ which variant }
							CASE PPCLocationKind OF
							   {ppcNoLocation:	storage not used by this value}
								ppcNBPLocation:		
										(nbpEntity: EntityName);		{ NBP name entity }
								ppcNBPTypeLocation:
										(nbpType: Str32);				{ just the NBP type string, for PPCOpen }
						END;


	PortInfoPtr = 	^PortInfoRec;
	PortInfoRec = 	RECORD
						filler1:		SignedByte;
						authRequired:	Boolean;
						name:			PPCPortRec;
					END;
	PortInfoArrayPtr = ^PortInfoArray;
	PortInfoArray	 = ARRAY [0..0] OF PortInfoRec;


	PPCOpenPBPtr = ^PPCOpenPBRec;
	PPCOpenPBRec = RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }
			{ 38 <--  }		portRefNum: 	PPCPortRefNum;				{ Port Reference										}			
							filler1:		LongInt;					
			{ 44 -->  }		serviceType:	PPCServiceType; 			{ Bit field describing the requested port service		}	
			{ 45 -->  }		resFlag:		SignedByte;					{ Must be set to 0										}
			{ 46 -->  }		portName:		PPCPortPtr;					{ PortName for PPC 										}
			{ 50 -->  }		locationName:	LocationNamePtr;			{ If NBP  Registration is required 						}
			{ 54 -->  }		networkVisible: Boolean; 					{ make this network visible on network 					}
			{ 55 <--  }		nbpRegistered:	Boolean; 					{ The given location name was registered on the network	}
						END;
						
					
	PPCInformPBPtr	= ^PPCInformPBRec;
	PPCInformPBRec	= RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
			{ 38 -->  }		portRefNum: 	PPCPortRefNum;				{ Port Identifier										}			
			{ 40 <--  }		sessRefNum:		PPCSessRefNum;				{ Session Reference 									}
			{ 44 <--  }		serviceType:	PPCServiceType; 			{ Status Flags for type of session, local, remote 		}	
			{ 45 -->  }		autoAccept: 	Boolean;					{ if true session will be accepted automatically 		}
			{ 46 -->  }		portName:		PPCPortPtr;					{ Buffer for Source PPCPortRec 							}
			{ 50 -->  }		locationName:	LocationNamePtr;			{ Buffer for Source LocationNameRec 					}
			{ 54 -->  }		userName:		StringPtr;					{ Buffer for Soure user's name trying to link. 			}
			{ 58 <--  }		userData:		LongInt;					{ value included in PPCStart's userData 	  			}
			{ 62 <--  }		requestType:	PPCSessionOrigin;			{ Local or Network										}
						END;
	
	
	PPCStartPBPtr	= ^PPCStartPBRec;
	PPCStartPBRec	= RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
			{ 38 -->  }		portRefNum: 	PPCPortRefNum;				{ Port Identifier										}			
			{ 40 <--  }		sessRefNum:		PPCSessRefNum;				{ Session Reference 									}
			{ 44 <--  }		serviceType:	PPCServiceType; 			{ Actual service method (realTime) 						}	
			{ 45 -->  }		resFlag: 		SignedByte;					{ Must be set to 0 										}
			{ 46 -->  }		portName:		PPCPortPtr;					{ Destination portName		 							}
			{ 50 -->  }		locationName:	LocationNamePtr;			{ NBP or NAS style service location name  				}
			{ 54 <--  }		rejectInfo:		LongInt;					{ reason for rejecting the session request 				}
			{ 58 -->  }		userData:		LongInt;					{ Copied to destination PPCInform parameter block		}
			{ 62 -->  }		userRefNum:		LongInt;					{ userRefNum (obtained during login process)   			}
						END;
	
	
	PPCAcceptPBPtr = ^PPCAcceptPBRec;
	PPCAcceptPBRec = RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
							filler1: 		Integer;						
			{ 40 -->  }		sessRefNum:		PPCSessRefNum;				{ Session Reference }
						END;
						
						
	PPCRejectPBPtr = ^PPCRejectPBRec;
	PPCRejectPBRec = RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
							filler1: 		Integer;							
			{ 40 -->  }		sessRefNum:		PPCSessRefNum;				{ Session Reference }
							filler2:		Integer;
							filler3:		LongInt;
							filler4:		LongInt;
			{ 54 -->  }		rejectInfo:		LongInt;					{ reason for rejecting the session request 	}
						END;
	
	
	PPCWritePBPtr = ^PPCWritePBRec;
	PPCWritePBRec = RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
							filler1:		Integer;					
			{ 40 -->  }		sessRefNum:		PPCSessRefNum;				{ Session Reference 								}
			{ 44 -->  }		bufferLength:	Size;						{ Length of the message buffer 						}
			{ 48 <--  }		actualLength:	Size;						{ Actual Length Written								}
			{ 52 -->  }		bufferPtr:		Ptr;						{ Pointer to message buffer 						}
			{ 56 -->  }		more:			Boolean; 					{ if more data in this block will be written 		}
							filler2:		SignedByte; 				
			{ 58 -->  }		userData:		LongInt;					{ Message block userData Uninterpreted by PPC		}
			{ 62 -->  }		blockCreator:	OSType;						{ Message block creator Uninterpreted by PPC		}
			{ 66 -->  }		blockType:		OSType;						{ Message block type Uninterpreted by PPC			}
						END;
	
	
	PPCReadPBPtr = ^PPCReadPBRec;
	PPCReadPBRec = RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
							filler1:		Integer;					
			{ 40 -->  }		sessRefNum:		PPCSessRefNum;				{ Session Reference 								}
			{ 44 -->  }		bufferLength:	Size;						{ Length of the message buffer 						}
			{ 48 <--  }		actualLength:	Size;						{ Actual length read								}
			{ 52 -->  }		bufferPtr:		Ptr;						{ Pointer to message buffer 						}
			{ 56 <--  }		more:			Boolean; 					{ if true more data in this block to be read		}
							filler2:		SignedByte; 				
			{ 58 <--  }		userData:		LongInt;					{ Message block userData Uninterpreted by PPC		}
			{ 62 <--  }		blockCreator:	OSType;						{ Message block creator Uninterpreted by PPC		}
			{ 66 <--  }		blockType:		OSType;						{ Message block type Uninterpreted by PPC			}
						END;
	
	
	PPCEndPBPtr = ^PPCEndPBRec;
	PPCEndPBRec   = RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
							filler1:		Integer;					
			{ 40 -->  }		sessRefNum:		PPCSessRefNum;				{ Session Reference 								}
						END;
	
	
	PPCClosePBPtr = ^PPCClosePBRec;
	PPCClosePBRec  = RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
			{ 38 -->  }		portRefNum: 	PPCPortRefNum;				{ Port Identifier									}			
						END;
	
	
	IPCListPortsPBPtr = ^IPCListPortsPBRec;
	IPCListPortsPBRec  = RECORD
							qLink:			Ptr;						{ reserved }
							csCode:			Integer;					{ reserved }
							intUse: 		Integer;					{ reserved }
							intUsePtr:		Ptr;						{ reserved }
							ioCompletion:	PPCCompProcPtr;
							ioResult:		OSErr;
							reserved:		ARRAY [1..5] OF LongInt;	{ reserved }	
							filler1:		Integer;		
			{ 40 -->  }		startIndex: 	Integer;					{ Start Index 												}
			{ 42 -->  }		requestCount:	Integer;					{ Number of entries to be returned 							}
			{ 44 <--  }		actualCount:	Integer;					{ Actual Number of entries to be returned					}
			{ 46 -->  }		portName:		PPCPortPtr;					{ PortName Match 											}
			{ 50 -->  }		locationName:	LocationNamePtr;			{ NBP or NAS type name to locate the Port Location 			}
			{ 54 -->  }		bufferPtr:		PortInfoArrayPtr;			{ Pointer to a buffer requestCount*sizeof(PortInfo) bytes big }							
						END;
	
	
	PPCParamBlockPtr = ^PPCParamBlockRec;
	PPCParamBlockRec = RECORD
						CASE Integer OF
							0: (openParam: 		PPCOpenPBRec);
							1: (informParam:	PPCInformPBRec);
							2: (startParam:		PPCStartPBRec);
							3: (acceptParam:	PPCAcceptPBRec);
							4: (rejectParam:	PPCRejectPBRec);
							5: (writeParam:		PPCWritePBRec);
							6: (readParam: 		PPCReadPBRec);
							7: (endParam:		PPCEndPBRec);
							8: (closeParam:		PPCClosePBRec);
							9: (listPortsParam: IPCListPortsPBRec);
					END;

FUNCTION PPCInit: OSErr;
INLINE $7000,$A0DD,$3E80;

FUNCTION PPCOpen(pb: PPCOpenPBPtr; async: Boolean): OSErr;
FUNCTION PPCOpenSync(pb: PPCOpenPBPtr): OSErr;
INLINE $205F,$7001,$A0DD,$3E80;
FUNCTION PPCOpenAsync(pb: PPCOpenPBPtr): OSErr;
INLINE $205F,$7001,$A4DD,$3E80;

FUNCTION PPCInform(pb: PPCInformPBPtr; async: Boolean): OSErr;
FUNCTION PPCInformSync(pb: PPCInformPBPtr): OSErr;
INLINE $205F,$7003,$A0DD,$3E80;
FUNCTION PPCInformAsync(pb: PPCInformPBPtr): OSErr;
INLINE $205F,$7003,$A4DD,$3E80;

FUNCTION PPCStart(pb: PPCStartPBPtr; async: Boolean): OSErr;
FUNCTION PPCStartSync(pb: PPCStartPBPtr): OSErr;
INLINE $205F,$7002,$A0DD,$3E80;
FUNCTION PPCStartAsync(pb: PPCStartPBPtr): OSErr;
INLINE $205F,$7002,$A4DD,$3E80;

FUNCTION PPCAccept(pb: PPCAcceptPBPtr; async: Boolean): OSErr;
FUNCTION PPCAcceptSync(pb: PPCAcceptPBPtr): OSErr;
INLINE $205F,$7004,$A0DD,$3E80;
FUNCTION PPCAcceptAsync(pb: PPCAcceptPBPtr): OSErr;
INLINE $205F,$7004,$A4DD,$3E80;

FUNCTION PPCReject(pb: PPCRejectPBPtr; async: Boolean): OSErr;
FUNCTION PPCRejectSync(pb: PPCRejectPBPtr): OSErr;
INLINE $205F,$7005,$A0DD,$3E80;
FUNCTION PPCRejectAsync(pb: PPCRejectPBPtr): OSErr;
INLINE $205F,$7005,$A4DD,$3E80;

FUNCTION PPCWrite(pb: PPCWritePBPtr; async: Boolean): OSErr;
FUNCTION PPCWriteSync(pb: PPCWritePBPtr): OSErr;
INLINE $205F,$7006,$A0DD,$3E80;
FUNCTION PPCWriteAsync(pb: PPCWritePBPtr): OSErr;
INLINE $205F,$7006,$A4DD,$3E80;

FUNCTION PPCRead(pb: PPCReadPBPtr; async: Boolean): OSErr;
FUNCTION PPCReadSync(pb: PPCReadPBPtr): OSErr;
INLINE $205F,$7007,$A0DD,$3E80;
FUNCTION PPCReadAsync(pb: PPCReadPBPtr): OSErr;
INLINE $205F,$7007,$A4DD,$3E80;

FUNCTION PPCEnd(pb: PPCEndPBPtr; async: Boolean): OSErr;
FUNCTION PPCEndSync(pb: PPCEndPBPtr): OSErr;
INLINE $205F,$7008,$A0DD,$3E80;
FUNCTION PPCEndAsync(pb: PPCEndPBPtr): OSErr;
INLINE $205F,$7008,$A4DD,$3E80;

FUNCTION PPCClose(pb: PPCClosePBPtr; async: Boolean): OSErr;
FUNCTION PPCCloseSync(pb: PPCClosePBPtr): OSErr;
INLINE $205F,$7009,$A0DD,$3E80;
FUNCTION PPCCloseAsync(pb: PPCClosePBPtr): OSErr;
INLINE $205F,$7009,$A4DD,$3E80;

FUNCTION IPCListPorts(pb: IPCListPortsPBPtr; async: Boolean): OSErr; 
FUNCTION IPCListPortsSync(pb: IPCListPortsPBPtr): OSErr;
INLINE $205F,$700A,$A0DD,$3E80;
FUNCTION IPCListPortsAsync(pb: IPCListPortsPBPtr): OSErr;
INLINE $205F,$700A,$A4DD,$3E80;

FUNCTION DeleteUserIdentity (userRef: LongInt): OSErr;

FUNCTION GetDefaultUser (VAR userRef: LongInt; userName: Str255): OSErr;

FUNCTION StartSecureSession (pb:			PPCStartPBPtr;
							userName:		Str255;
							useDefault: 	Boolean;
							allowGuest: 	Boolean;
							VAR guestSelected:	Boolean;
							prompt: 		Str255): OSErr;

FUNCTION PPCBrowser (	 prompt:			Str255;
						 applListLabel:		Str255;
						 defaultSpecified:	Boolean;
					 VAR theLocation:		LocationNameRec;
					 VAR thePortInfo:		PortInfoRec;
					 	 portFilter:		PPCFilterProcPtr;
					 	 theLocNBPType:		Str32): OSErr;
			INLINE $303C,$0D00,$A82B;


{$ENDC}    { UsingPPCToolBox }

{$IFC NOT UsingIncludes}
	END.
{$ENDC}
